﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using MediaPortal.Configuration;
using MediaPortal.GUI.Library;

namespace ProcessSkeleton
{
    public class Skeleton : IPlugin, ISetupForm
    {
        private BackgroundWorker worker;
        #region IPlugin Members

        public void Start()
        {
            MediaPortal.ServiceImplementations.Log.Info("[ProcessSkeleton] Start");

            worker = new BackgroundWorker();
            worker.DoWork += new DoWorkEventHandler(worker_DoWork);
            worker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(worker_RunWorkerCompleted);
            worker.RunWorkerAsync();
        }

        public void Stop()
        {
            MediaPortal.ServiceImplementations.Log.Info("[ProcessSkeleton] Stop");
        }

        #endregion

        #region ISetupForm Members

        public string Author()
        {
            return "Me";
        }

        public bool CanEnable()
        {
            return true;
        }

        public bool DefaultEnabled()
        {
            return true;
        }

        public string Description()
        {
            return "The Description";
        }

        public bool GetHome(out string strButtonText, out string strButtonImage, out string strButtonImageFocus, out string strPictureImage)
        {
            strButtonText = null;
            strButtonImage = null;
            strButtonImageFocus = null;
            strPictureImage = null;
            return false;
        }

        public int GetWindowId()
        {
            return -1;
        }

        public bool HasSetup()
        {
            return false;
        }

        public string PluginName()
        {
            return "Skeleton";
        }

        public void ShowPlugin()
        {
            // no setup
        }

        #endregion

        private void worker_DoWork(object sender, DoWorkEventArgs e)
        {
            int i = 0;
            while (!worker.CancellationPending)
            {
                System.Threading.Thread.Sleep(5000);
                MediaPortal.ServiceImplementations.Log.Info("[ProcessSkeleton] Hello {0}", i++);
            }
        }

        private void worker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            Stop();
        }
    }
}
